#region Copyright Syncfusion Inc. 2001 - 2016
// Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Data.SqlServerCe;
using System.Web.Script.Serialization;
using Syncfusion.Olap.Manager;
using Syncfusion.Olap.Reports;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.Olap;
using Syncfusion.PivotAnalysis.Base;
using System.Data;

namespace PivotChart_datatable.WebAPI
{
    class OrderDetails
    {
        public static DataTable GetOrderDetials()
        {
            try
            {
                string dbConString = "DataSource=" + System.Web.Hosting.HostingEnvironment.MapPath("~/database/Northwind.sdf");

                DataSet ds = new DataSet();

                //In below provide full path of your database(*.sdf) location.
                using (SqlCeConnection con = new SqlCeConnection(dbConString))
                {
                    con.Open();
                    SqlCeCommand cmd = new SqlCeCommand(@"SELECT Top(100) [Order ID], [Product ID], [Unit Price], Quantity
                                                          FROM [Order Details] ", con);
                    SqlCeDataAdapter da = new SqlCeDataAdapter(cmd);

                    da.Fill(ds);

                    //return the DataTable
                    return ds.Tables[0];
                }
            }
            catch (Exception e)
            {
                return null;
            }
        }
    }

    public class RelationalChartController : ApiController
    {
        Syncfusion.JavaScript.PivotChart PivotChart = new Syncfusion.JavaScript.PivotChart();
        JavaScriptSerializer serializer = new JavaScriptSerializer();

        [System.Web.Http.ActionName("InitializeChart")]
        [System.Web.Http.HttpPost]
        public Dictionary<string, object> InitializeChart(Dictionary<string, object> jsonResult)
        {
            this.BindData();
            return PivotChart.GetJsonData(jsonResult["action"].ToString(), OrderDetails.GetOrderDetials());
        }

        [System.Web.Http.ActionName("DrillChart")]
        [System.Web.Http.HttpPost]
        public Dictionary<string, object> DrillChart(Dictionary<string, object> jsonResult)
        {
            this.BindData();
            return PivotChart.GetJsonData(jsonResult["action"].ToString(), OrderDetails.GetOrderDetials(), jsonResult["drilledSeries"].ToString());
        }

        [System.Web.Http.ActionName("Export")]
        [System.Web.Http.HttpPost]
        public void Export()
        {
            string args = HttpContext.Current.Request.Form.GetValues(0)[0];
            string fileName = "Sample";
            PivotChart.ExportPivotChart(args, fileName, System.Web.HttpContext.Current.Response);
        }

        private void BindData()
        {
            this.PivotChart.PivotEngine.PivotColumns.Add(new PivotItem { FieldHeader = "OrderID", FieldMappingName = "Order ID", TotalHeader = "Total" });
            this.PivotChart.PivotEngine.PivotRows.Add(new PivotItem { FieldHeader = "ProductID", FieldMappingName = "Product ID", TotalHeader = "Total" });
            this.PivotChart.PivotEngine.PivotCalculations.Add(new PivotComputationInfo { CalculationName = "UnitPrice", FieldName = "Unit Price", Format = "C" });
        }
    }
}